diff -Naur newlib-1.20.0.orig/newlib/ChangeLog newlib-1.20.0/newlib/ChangeLog
--- newlib-1.20.0.orig/newlib/ChangeLog	2011-12-19 23:03:17.000000000 +0100
+++ newlib-1.20.0/newlib/ChangeLog	2011-12-20 18:04:03.930129270 +0100
@@ -1,3 +1,8 @@
+2011-12-20  Aleksandr Platonov  <pam@oktetlabs.ru>
+
+	* fvwrite.c (__sfvwrite_r): Set __SMBF flag to avoid double free in
+	fclose.  Enhance comment.
+
 2011-12-19  Jeff Johnston  <jjohnstn@redhat.com>
 
 	* NEWS: Update with 1.20.0 info.
@@ -16,14 +21,6 @@
 	* libm/libm.texinfo: Ditto.
 	* libc/sys/linux/shared.ld: Add VERS_1.20
 
-2011-12-13  Richard Earnshaw  <rearnsha@arm.com>
-	    Thomas Klein  <th.r.klein@web.de>
-
-	* libc/sys/arm/crt0.S: Manually set the target architecture
-	when compiling for Thumb1 on EABI targets.
-	Don't use SWI on M-profile cores.
-	Avoid v6-only Thumb-1 MOV instruction.
-
 2011-12-12  Akio Idehara  <zbe64533@gmail.com>
 
 	* libc/time/strftime.c (get_era_info): Fix off-by-one error in month
@@ -48,51 +45,16 @@
 	* libc/iconv/ccs/Makefile.am: Add missing backslash.
 	* libc/iconv/ccs/Makefile.in: Regenerate.
 
-2011-10-18  Dr David Alan Gilbert  <david.gilbert@linaro.org>
-
-	* libc/machine/arm/Makefile.am (lib_a_SOURCES): Add memchr-stub.c,
-	memchr.S.
-	* libc/machine/arm/arm_asm.h: Add ifdef to allow it to be included
-	in .S files.
-	* libc/machine/arm/memchr-stub.c: New file - just selects what to
-	compile.
-	* libc/machine/arm/memchr.S: New file - ARMv6t2/v7 version.
-
-	* libc/machine/arm/Makefile.am (lib_a_SOURCES): Add strlen-armv7.S.
-	* libc/machine/arm/strlen-armv7.S: New file.
-	* libc/machine/arm/strlen.c: Add ifdef optimised code so it isn't
-	for v7 or 6t2.
-
-	* libc/machine/arm/Makefile.in: Regenerate.
-
 2011-10-11  Steven Abner <pheonix@zoomtown.com>
 
 	* libc/time/mktm_r.c: (__tzcalc_limits) Fix Julian day calculation.
 	* libc/time/mktime.c: (mktime) Fix tm_yday, tm_mday updating when
 	timezone causes roll over.
 
-2011-10-10  Nick Clifton  <nickc@redhat.com>
-
-	* libc/sys/arm/crt0.S: Synchronise with libgloss version.
-	* libc/sys/arm/arm.h: Imported from libgloss.
-
 2011-10-04  Greta Yorsh  <Greta.Yorsh@arm.com>
 
 	* testsuite/newlib.string/memcpy-1.c: New test.
 
-2011-10-04  Nick Clifton  <nickc@redhat.com>
-
-	* libc/machine/arm/memcpy.S: Fix unaligned access copying.
-
-2011-09-29  Greta Yorsh  <Greta.Yorsh@arm.com>
-
-	* libc/machine/arm/memcpy.S: New file.  Contains a hand coded
-	memcpy function optimized for the cortex-a15.
-	* libc/machine/arm/memcpy-stub.c: New file.
-	* libc/machine/arm/Makefile.am (lib_a_SOURCES): Add memcpy-stub.c,
-	memcpy.S.
-	* libc/machine/arm/Makefile.in: Regenerate.
-
 2011-09-08  Jeff Johnston  <jjohnstn@redhat.com>
 
 	* testsuite/lib/flags.exp: Add logic to add the
@@ -492,16 +454,6 @@
 	* libm/math/w_tgamma.c: Only build ifndef _DOUBLE_IS_32BITS.
 	* libm/math/wf_tgamma.c: Map tgamma to tgammaf, ifdef _DOUBLE_IS_32BITS.
 
-2011-01-12  Jeff Johnston  <jjohnstn@redhat.com>
-
-	* configure.host: Add noinclude variable to allow specification
-	of header files to remove from installation.
-	* acinclude.m4: Provide NO_INCLUDE_LIST variable based on
-	noinclude variable in configure.host.
-	* configure: Regenerated.
-	* Makefile.am: Remove all header files in NO_INCLUDE_LIST.
-	* Makefile.in: Regenerated.
-
 2011-01-12  Yaakov Selkowitz  <yselkowitz@users.sourceforge.net>
 
 	* libc/sys/linux/sys/signal.h (sig_t): Move from here...
diff -Naur newlib-1.20.0.orig/newlib/ChangeLog.rtems newlib-1.20.0/newlib/ChangeLog.rtems
--- newlib-1.20.0.orig/newlib/ChangeLog.rtems	1970-01-01 01:00:00.000000000 +0100
+++ newlib-1.20.0/newlib/ChangeLog.rtems	2011-12-20 18:04:03.930129270 +0100
@@ -0,0 +1,146 @@
+2011-12-16	Ralf Corsépius  <ralf.corsepius@rtems.org>
+
+	* libc/include/sys/time.h: Add adjtime.
+	* libc/include/sys/resource.h: Add getrusage.
+
+2011-10-06	Ralf Corsépius  <ralf.corsepius@rtems.org>
+
+	* libc/sys/rtems/machine/_types.h (_ssize_t): Special case __ARM_EABI__.
+
+2011-08-11	Ralf Corsépius  <ralf.corsepius@rtems.org>
+
+	* libc/stdio/tmpnam.c: Use PRIxPTR instead of %x.
+
+2011-08-11	Ralf Corsépius  <ralf.corsepius@rtems.org>
+
+	* libc/search/hcreate_r.c: #ifdef 0 unused vars ie, idx.
+
+2011-04-19  Ralf Corsépius <ralf.corsepius@rtems.org>
+
+	* libc/include/stdint.h: Rework SIZE_MAX.
+
+2011-02-07  Ralf Corsépius  <ralf.corsepius@rtems.org>
+
+	* libc/include/stdlib.h: More ansi-compliance.
+
+2011-02-01  Ralf Corsépius  <ralf.corsepius@rtems.org>
+	
+	* libc/include/stdio.h: More ansi-compliance.
+
+	* libc/include/stdlib.h: Remove atoff.
+	* libc/stdlib/atoff.c: Remove.
+	* libc/stdlib/atof.c: Remove atoff.
+	* libc/stdlib/Makefile.am: Remove atoff.
+	* libc/stdlib/Makefile.in: Regenerate.
+
+	* libc/include/stdio.h: Make fdopen accessible to c99.
+
+2011-01-11  Ralf Corsépius  <ralf.corsepius@rtems.org>
+
+	* libc/include/string.h: Remove Cygwin DEFS_H kludge.
+
+2011-01-07	Ralf Corsépius  <ralf.corsepius@rtems.org>
+
+	* libc/stdio/open_memstream.c: Replace 64 * 1024 with 0x10000 to 
+	avoid integer overflow on h8300.
+
+2011-01-05	Ralf Corsépius  <ralf.corsepius@rtems.org>
+
+	* libc/stdio/tmpnam.c: Include <stdint.h>.
+	Use intptr_t instead of _POINTER_INT for improved portability.
+	* libc/misc/__dprintf.c: Include <stdint.h>
+	Use intptr_t instead of _POINTER_INT for improved portability.
+
+2011-01-05	Ralf Corsépius  <ralf.corsepius@rtems.org>
+
+	* libm/common/s_round.c: Cast const int to __int32_t.
+
+2011-01-04	Ralf Corsépius  <ralf.corsepius@rtems.org>
+
+	* libm/math/e_scalb.c: Include <limits.h>.
+	Don't rely on 65000 being a valid int.
+
+2011-01-04	Ralf Corsépius  <ralf.corsepius@rtems.org>
+
+	* libc/posix/readdir.c:	Include <stdint.h>.
+	Cast to intptr_t instead of int.
+
+2011-01-04	Ralf Corsépius  <ralf.corsepius@rtems.org>
+
+	* libc/string/memccpy.c, libc/string/memchr.c,
+	libc/string/memcmp.c, libc/string/memcpy.c,
+	libc/string/memmove.c, libc/string/mempcpy.c,
+	libc/string/memset.c, libc/string/stpcpy.c,
+	libc/string/stpncpy.c, libc/string/strcpy.c,
+	libc/string/strlen.c, libc/string/strncat.c,
+	libc/string/strncpy.c (UNALIGNED):
+	Include <stdint.h>.
+	Cast to intptr_t instead of long.
+
+2011-01-04	Ralf Corsépius  <ralf.corsepius@rtems.org>
+
+	* Makefile.am: Don't install include/rpc/*.h.
+	* Makefile.in: Regenerate.
+	* libc/Makefile.am: Install include/rpc/xdr.h include/rpc/types.h. 
+	* libc/Makefile.in: Regenerate.
+
+2010-12-31  Ralf Corsepius  <ralf.corsepius@rtems.org>
+
+	* doc/makedoc.c: Add cludge to make makedoc 64bit compliant.
+
+2010-12-30	Ralf Corsépius  <ralf.corsepius@rtems.org>
+
+	* libc/include/signal.h: Don't provide sighandler_t.
+
+2010-12-29	Ralf Corsépius  <ralf.corsepius@rtems.org>
+
+	* libc/include/sys/dir.h: Remove.
+
+2010-08-10	Ralf Corsépius <ralf.corsepius@rtems.org>
+
+	PR 1475/newlib:
+	* libc/include/stdint.h: Fall back to compute SIZE_MAX based on
+	__SIZEOF_SIZE_T__ and __CHAR_BIT__ if available.
+
+2010-08-04	Ralf Corsépius <ralf.corsepius@rtems.org>
+
+	* libc/string/strcat.c: 
+	Include <stdint.h>. Use uintptr_t instead of long in ALIGNED.
+	* libc/string/strchr.c, libc/string/strcmp.c, libc/string/strncmp.c:
+	Include <stdint.h>. Use uintptr_t instead of long in UNALIGNED.
+
+2010-03-25	Ralf Corsépius <ralf.corsepius@rtems.org>
+
+	* libc/include/string.h: Remove bcmp, bcopy, bzero, ffs, index, rindex,
+	strcasecmp, strncasecmp (Moved to strings.h).
+	Remove strcmpi, stricmp, strncmpi, strnicmp.
+
+2009-12-18  Ralf Corsépius <ralf.corsepius@rtems.org>
+
+	* libc/search/db_local.h:
+	Use __uint32_t instead of u_int (prototype mismatches).
+	* libc/search/extern.h (__buf_init): 
+	Use __uint32_t instead of int (16 bit target portability).
+	* libc/search/hash_buf.c: Use ptrdiff_t instead of __uint32_t,
+	use __uint32_t instead of int (16 bit target portability).
+	* libc/search/hash.h: Use __uint32_it instead of int
+	(16 bit target portability).
+	* libm/common/modfl.c: Add cast to (double*) to avoid GCC warning.
+
+2009-10-29  Ralf Corsépius <ralf.corsepius@rtems.org>
+
+	* libc/include/inttypes.h: 
+	Rework logic to determine PRI*PTR.
+	Prefer long64 over longlong64.
+	* libc/include/machine/_default_types.h: 
+	Sync logic for __int32 with stdint.h (Prefer long over int).
+	* libc/include/stdint.h:
+	Remove __SPU__ hack.
+	Prefer int for int16_t (sync with _default_types.h).
+	Rework intptr_t determination.
+
+2009-03-09  Ralf Corsépius <ralf.corsepius@rtems.org>
+
+	* libc/machine/powerpc/times.c: Remove.
+	* libc/machine/powerpc/Makefile.am: Remove times.c.
+	* libc/machine/powerpc/Makefile.in: Regenerate.
diff -Naur newlib-1.20.0.orig/newlib/configure.host newlib-1.20.0/newlib/configure.host
--- newlib-1.20.0.orig/newlib/configure.host	2011-11-29 07:33:48.000000000 +0100
+++ newlib-1.20.0/newlib/configure.host	2011-12-20 18:04:03.933129312 +0100
@@ -46,7 +46,6 @@
 #   crt1_dir            directory where crt1 object is found
 #   have_crt0		"yes"/"no" if crt0 is/isn't provided.
 #			"" if crt0 is provided when sys_dir is set
-#   noinclude		list of include files to not install
 
 newlib_cflags=
 libm_machine_dir=
@@ -59,7 +58,6 @@
 xdr_dir=
 syscall_dir=
 unix_dir=
-noinclude=
 mach_add_setjmp=
 crt1=
 crt1_dir=
@@ -787,11 +785,6 @@
 	fi
 fi
 
-# Remove rpc headers if xdr_dir not specified
-if [ "x${xdir_dir}" = "x" ]; then
-	noinclude="${noinclude} rpc/types.h rpc/xdr.h"
-fi
-
 if test -z "${have_crt0}" && test -n "${sys_dir}"; then
   have_crt0="yes"
 fi
diff -Naur newlib-1.20.0.orig/newlib/doc/makedoc.c newlib-1.20.0/newlib/doc/makedoc.c
--- newlib-1.20.0.orig/newlib/doc/makedoc.c	2009-03-25 22:16:04.000000000 +0100
+++ newlib-1.20.0/newlib/doc/makedoc.c	2011-12-20 18:04:03.933129312 +0100
@@ -57,7 +57,7 @@
 {
     char *ptr;
     unsigned int write_idx;
-    unsigned int size;
+    size_t size;
 } string_type;
 
 
@@ -68,7 +68,7 @@
 
 static void DEFUN(init_string_with_size,(buffer, size),
 	   string_type *buffer AND
-	   unsigned int size )
+	   size_t size )
 {
   buffer->write_idx = 0;
   buffer->size = size;
@@ -219,8 +219,8 @@
 stinst_type *pc;
 stinst_type sstack[STACK];
 stinst_type *ssp = &sstack[0];
-int istack[STACK];
-int *isp = &istack[0];
+long istack[STACK];
+long *isp = &istack[0];
 
 typedef int *word_type;
 
@@ -270,7 +270,7 @@
 {
     isp++;
     pc++;
-    *isp = (int)(*pc);
+    *isp = (long)(*pc);
     pc++;
     
 }
diff -Naur newlib-1.20.0.orig/newlib/libc/include/inttypes.h newlib-1.20.0/newlib/libc/include/inttypes.h
--- newlib-1.20.0.orig/newlib/libc/include/inttypes.h	2009-01-19 23:02:06.000000000 +0100
+++ newlib-1.20.0/newlib/libc/include/inttypes.h	2011-12-20 18:04:03.934129334 +0100
@@ -242,15 +242,17 @@
 #define SCNxMAX		__SCNMAX(x)
 
 /* ptr types */
-#if __have_long64
-#define __PRIPTR(x) __STRINGIFY(l##x)
-#define __SCNPTR(x) __STRINGIFY(l##x)
-#elif __have_longlong64
-#define __PRIPTR(x) __STRINGIFY(ll##x)
-#define __SCNPTR(x) __STRINGIFY(ll##x)
+#if INTPTR_MAX == INT64_MAX
+#define __PRIPTR(x) __PRI64(x)
+#define __SCNPTR(x) __SCN64(x)
+#elif INTPTR_MAX == INT32_MAX
+#define __PRIPTR(x) __PRI32(x)
+#define __SCNPTR(x) __SCN32(x)
+#elif INTPTR_MAX == INT16_MAX
+#define __PRIPTR(x) __PRI16(x)
+#define __SCNPTR(x) __SCN16(x)
 #else
-#define __PRIPTR(x) __STRINGIFY(x)
-#define __SCNPTR(x) __STRINGIFY(x)
+#error cannot determine PRI*PTR
 #endif
 
 #define PRIdPTR		__PRIPTR(d)
diff -Naur newlib-1.20.0.orig/newlib/libc/include/machine/_default_types.h newlib-1.20.0/newlib/libc/include/machine/_default_types.h
--- newlib-1.20.0.orig/newlib/libc/include/machine/_default_types.h	2008-06-12 00:14:54.000000000 +0200
+++ newlib-1.20.0/newlib/libc/include/machine/_default_types.h	2011-12-20 18:04:03.935129353 +0100
@@ -54,14 +54,14 @@
 #endif
 #endif
 
-#if __EXP(INT_MAX) == 0x7fffffffL
-typedef signed int __int32_t;
-typedef unsigned int __uint32_t;
-#define ___int32_t_defined 1
-#elif __EXP(LONG_MAX) == 0x7fffffffL
+#if __EXP(LONG_MAX) == 0x7fffffffL
 typedef signed long __int32_t;
 typedef unsigned long __uint32_t;
 #define ___int32_t_defined 1
+#elif __EXP(INT_MAX) == 0x7fffffffL
+typedef signed int __int32_t;
+typedef unsigned int __uint32_t;
+#define ___int32_t_defined 1
 #elif __EXP(SHRT_MAX) == 0x7fffffffL
 typedef signed short __int32_t;
 typedef unsigned short __uint32_t;
diff -Naur newlib-1.20.0.orig/newlib/libc/include/signal.h newlib-1.20.0/newlib/libc/include/signal.h
--- newlib-1.20.0.orig/newlib/libc/include/signal.h	2011-05-04 13:26:21.000000000 +0200
+++ newlib-1.20.0/newlib/libc/include/signal.h	2011-12-20 18:04:03.935129353 +0100
@@ -7,10 +7,6 @@
 _BEGIN_STD_C
 
 typedef int	sig_atomic_t;		/* Atomic entity type (ANSI) */
-#ifndef _POSIX_SOURCE
-typedef _sig_func_ptr sig_t;		/* BSD naming */
-typedef _sig_func_ptr sighandler_t;	/* glibc naming */
-#endif /* !_POSIX_SOURCE */
 
 #define SIG_DFL ((_sig_func_ptr)0)	/* Default action */
 #define SIG_IGN ((_sig_func_ptr)1)	/* Ignore action */
diff -Naur newlib-1.20.0.orig/newlib/libc/include/stdint.h newlib-1.20.0/newlib/libc/include/stdint.h
--- newlib-1.20.0.orig/newlib/libc/include/stdint.h	2009-04-24 23:55:07.000000000 +0200
+++ newlib-1.20.0/newlib/libc/include/stdint.h	2011-12-20 18:04:03.935129353 +0100
@@ -33,7 +33,7 @@
 /* Check if "long" is 64bit or 32bit wide */
 #if __STDINT_EXP(LONG_MAX) > 0x7fffffff
 #define __have_long64 1
-#elif __STDINT_EXP(LONG_MAX) == 0x7fffffff && !defined(__SPU__)
+#elif __STDINT_EXP(LONG_MAX) == 0x7fffffff
 #define __have_long32 1
 #endif
 
@@ -49,14 +49,14 @@
 #define __int_least8_t_defined 1
 #endif
 
-#if __STDINT_EXP(SHRT_MAX) == 0x7fff
-typedef signed short int16_t;
-typedef unsigned short uint16_t;
-#define __int16_t_defined 1
-#elif __STDINT_EXP(INT_MAX) == 0x7fff
+#if __STDINT_EXP(INT_MAX) == 0x7fff
 typedef signed int int16_t;
 typedef unsigned int uint16_t;
 #define __int16_t_defined 1
+#elif __STDINT_EXP(SHRT_MAX) == 0x7fff
+typedef signed short int16_t;
+typedef unsigned short uint16_t;
+#define __int16_t_defined 1
 #elif __STDINT_EXP(SCHAR_MAX) == 0x7fff
 typedef signed char int16_t;
 typedef unsigned char uint16_t;
@@ -239,6 +239,29 @@
  * GCC doesn't provide an appropriate macro for [u]intptr_t
  * For now, use __PTRDIFF_TYPE__
  */
+#if defined(__SIZEOF_POINTER__)
+#if __SIZEOF_POINTER__ == 8
+  typedef int64_t intptr_t;
+  typedef uint64_t uintptr_t;
+#define INTPTR_MAX INT64_MAX
+#define INTPTR_MIN INT64_MIN
+#define UINTPTR_MAX UINT64_MAX
+#elif __SIZEOF_POINTER__ == 4
+  typedef int32_t intptr_t;
+  typedef uint32_t uintptr_t;
+#define INTPTR_MAX INT32_MAX
+#define INTPTR_MIN INT32_MIN
+#define UINTPTR_MAX UINT32_MAX
+#elif __SIZEOF_POINTER__ == 2
+  typedef int16_t intptr_t;
+  typedef uint16_t uintptr_t;
+#define INTPTR_MAX INT16_MAX
+#define INTPTR_MIN INT16_MIN
+#define UINTPTR_MAX UINT16_MAX
+#else
+#error cannot determine intptr_t
+#endif
+#else
 #if defined(__PTRDIFF_TYPE__)
 typedef signed __PTRDIFF_TYPE__ intptr_t;
 typedef unsigned __PTRDIFF_TYPE__ uintptr_t;
@@ -260,6 +283,7 @@
 #define INTPTR_MIN (-__STDINT_EXP(LONG_MAX) - 1)
 #define UINTPTR_MAX (__STDINT_EXP(LONG_MAX) * 2UL + 1)
 #endif
+#endif
 
 /* Limits of Specified-Width Integer Types */
 
@@ -408,6 +432,8 @@
 /* This must match size_t in stddef.h, currently long unsigned int */
 #ifdef __SIZE_MAX__
 #define SIZE_MAX __SIZE_MAX__
+#elif defined(__SIZEOF_SIZE_T__) && defined(__CHAR_BIT__)
+#define SIZE_MAX (((1UL << (__SIZEOF_SIZE_T__ * __CHAR_BIT__ - 1)) - 1) * 2 + 1)
 #else
 #define SIZE_MAX (__STDINT_EXP(LONG_MAX) * 2UL + 1)
 #endif
diff -Naur newlib-1.20.0.orig/newlib/libc/include/stdio.h newlib-1.20.0/newlib/libc/include/stdio.h
--- newlib-1.20.0.orig/newlib/libc/include/stdio.h	2010-02-26 10:41:43.000000000 +0100
+++ newlib-1.20.0/newlib/libc/include/stdio.h	2011-12-20 18:04:03.936129371 +0100
@@ -308,7 +308,7 @@
  * Routines in POSIX 1003.1:2001.
  */
 
-#ifndef __STRICT_ANSI__
+#if (!defined(__STRICT_ANSI__) || (__STDC_VERSION__ >= 199901L))
 #ifndef _REENT_ONLY
 FILE *	_EXFUN(fdopen, (int, const char *));
 #endif
diff -Naur newlib-1.20.0.orig/newlib/libc/include/stdlib.h newlib-1.20.0/newlib/libc/include/stdlib.h
--- newlib-1.20.0.orig/newlib/libc/include/stdlib.h	2010-07-19 20:21:11.000000000 +0200
+++ newlib-1.20.0/newlib/libc/include/stdlib.h	2011-12-20 18:04:03.936129371 +0100
@@ -38,7 +38,7 @@
   long rem; /* remainder */
 } ldiv_t;
 
-#ifndef __STRICT_ANSI__
+#if !defined(__STRICT_ANSI__) || (__STDC_VERSION__ >= 199901L)
 typedef struct
 {
   long long int quot; /* quotient */
@@ -63,13 +63,12 @@
 int	_EXFUN(abs,(int));
 int	_EXFUN(atexit,(_VOID (*__func)(_VOID)));
 double	_EXFUN(atof,(const char *__nptr));
-#ifndef __STRICT_ANSI__
-float	_EXFUN(atoff,(const char *__nptr));
-#endif
 int	_EXFUN(atoi,(const char *__nptr));
-int	_EXFUN(_atoi_r,(struct _reent *, const char *__nptr));
 long	_EXFUN(atol,(const char *__nptr));
+#ifndef __STRICT_ANSI__
+int	_EXFUN(_atoi_r,(struct _reent *, const char *__nptr));
 long	_EXFUN(_atol_r,(struct _reent *, const char *__nptr));
+#endif /* ! __STRICT_ANSI__ */
 _PTR	_EXFUN(bsearch,(const _PTR __key,
 		       const _PTR __base,
 		       size_t __nmemb,
@@ -80,10 +79,10 @@
 _VOID	_EXFUN(exit,(int __status) _ATTRIBUTE ((noreturn)));
 _VOID	_EXFUN_NOTHROW(free,(_PTR));
 char *  _EXFUN(getenv,(const char *__string));
+#ifndef __STRICT_ANSI__
 char *	_EXFUN(_getenv_r,(struct _reent *, const char *__string));
 char *	_EXFUN(_findenv,(_CONST char *, int *));
 char *	_EXFUN(_findenv_r,(struct _reent *, _CONST char *, int *));
-#ifndef __STRICT_ANSI__
 extern char *suboptarg;			/* getsubopt(3) external variable */
 int	_EXFUN(getsubopt,(char **, char * const *, char **));
 #endif
@@ -91,16 +90,16 @@
 ldiv_t	_EXFUN(ldiv,(long __numer, long __denom));
 _PTR	_EXFUN_NOTHROW(malloc,(size_t __size));
 int	_EXFUN(mblen,(const char *, size_t));
-int	_EXFUN(_mblen_r,(struct _reent *, const char *, size_t, _mbstate_t *));
 int	_EXFUN(mbtowc,(wchar_t *, const char *, size_t));
-int	_EXFUN(_mbtowc_r,(struct _reent *, wchar_t *, const char *, size_t, _mbstate_t *));
 int	_EXFUN(wctomb,(char *, wchar_t));
-int	_EXFUN(_wctomb_r,(struct _reent *, char *, wchar_t, _mbstate_t *));
 size_t	_EXFUN(mbstowcs,(wchar_t *, const char *, size_t));
-size_t	_EXFUN(_mbstowcs_r,(struct _reent *, wchar_t *, const char *, size_t, _mbstate_t *));
 size_t	_EXFUN(wcstombs,(char *, const wchar_t *, size_t));
-size_t	_EXFUN(_wcstombs_r,(struct _reent *, char *, const wchar_t *, size_t, _mbstate_t *));
 #ifndef __STRICT_ANSI__
+int	_EXFUN(_mblen_r,(struct _reent *, const char *, size_t, _mbstate_t *));
+int	_EXFUN(_mbtowc_r,(struct _reent *, wchar_t *, const char *, size_t, _mbstate_t *));
+int	_EXFUN(_wctomb_r,(struct _reent *, char *, wchar_t, _mbstate_t *));
+size_t	_EXFUN(_mbstowcs_r,(struct _reent *, wchar_t *, const char *, size_t, _mbstate_t *));
+size_t	_EXFUN(_wcstombs_r,(struct _reent *, char *, const wchar_t *, size_t, _mbstate_t *));
 #ifndef _REENT_ONLY
 char *	_EXFUN(mkdtemp,(char *));
 int	_EXFUN(mkostemp,(char *, int));
@@ -133,10 +132,11 @@
 # endif
 #endif
 long	_EXFUN(strtol,(const char *__n, char **__end_PTR, int __base));
-long	_EXFUN(_strtol_r,(struct _reent *,const char *__n, char **__end_PTR, int __base));
 unsigned long _EXFUN(strtoul,(const char *__n, char **__end_PTR, int __base));
+#ifndef __STRICT_ANSI__
 unsigned long _EXFUN(_strtoul_r,(struct _reent *,const char *__n, char **__end_PTR, int __base));
-
+long	_EXFUN(_strtol_r,(struct _reent *,const char *__n, char **__end_PTR, int __base));
+#endif /* !__STRICT_ANSI__ */
 int	_EXFUN(system,(const char *__string));
 
 #ifndef __STRICT_ANSI__
@@ -163,33 +163,39 @@
 int	_EXFUN(rand_r,(unsigned *__seed));
 
 double _EXFUN(drand48,(_VOID));
-double _EXFUN(_drand48_r,(struct _reent *));
 double _EXFUN(erand48,(unsigned short [3]));
-double _EXFUN(_erand48_r,(struct _reent *, unsigned short [3]));
 long   _EXFUN(jrand48,(unsigned short [3]));
-long   _EXFUN(_jrand48_r,(struct _reent *, unsigned short [3]));
 _VOID  _EXFUN(lcong48,(unsigned short [7]));
-_VOID  _EXFUN(_lcong48_r,(struct _reent *, unsigned short [7]));
 long   _EXFUN(lrand48,(_VOID));
-long   _EXFUN(_lrand48_r,(struct _reent *));
 long   _EXFUN(mrand48,(_VOID));
-long   _EXFUN(_mrand48_r,(struct _reent *));
 long   _EXFUN(nrand48,(unsigned short [3]));
-long   _EXFUN(_nrand48_r,(struct _reent *, unsigned short [3]));
 unsigned short *
        _EXFUN(seed48,(unsigned short [3]));
+_VOID  _EXFUN(srand48,(long));
+long long _EXFUN(atoll,(const char *__nptr));
+#ifndef __STRICT_ANSI__
+double _EXFUN(_drand48_r,(struct _reent *));
+double _EXFUN(_erand48_r,(struct _reent *, unsigned short [3]));
+long   _EXFUN(_jrand48_r,(struct _reent *, unsigned short [3]));
+_VOID  _EXFUN(_lcong48_r,(struct _reent *, unsigned short [7]));
+long   _EXFUN(_lrand48_r,(struct _reent *));
+long   _EXFUN(_mrand48_r,(struct _reent *));
+long   _EXFUN(_nrand48_r,(struct _reent *, unsigned short [3]));
 unsigned short *
        _EXFUN(_seed48_r,(struct _reent *, unsigned short [3]));
-_VOID  _EXFUN(srand48,(long));
 _VOID  _EXFUN(_srand48_r,(struct _reent *, long));
-long long _EXFUN(atoll,(const char *__nptr));
 long long _EXFUN(_atoll_r,(struct _reent *, const char *__nptr));
+#endif /* ! __STRICT_ANSI__ */
+#if !defined(__STRICT_ANSI__) || (__STDC_VERSION__ >= 199901L)
 long long _EXFUN(llabs,(long long));
 lldiv_t	_EXFUN(lldiv,(long long __numer, long long __denom));
 long long _EXFUN(strtoll,(const char *__n, char **__end_PTR, int __base));
-long long _EXFUN(_strtoll_r,(struct _reent *, const char *__n, char **__end_PTR, int __base));
 unsigned long long _EXFUN(strtoull,(const char *__n, char **__end_PTR, int __base));
+#endif
+#ifndef __STRICT_ANSI__
+long long _EXFUN(_strtoll_r,(struct _reent *, const char *__n, char **__end_PTR, int __base));
 unsigned long long _EXFUN(_strtoull_r,(struct _reent *, const char *__n, char **__end_PTR, int __base));
+#endif /* ! __STRICT_ANSI__ */
 
 #ifndef __CYGWIN__
 _VOID	_EXFUN(cfree,(_PTR));
@@ -203,6 +209,7 @@
 
 #endif /* ! __STRICT_ANSI__ */
 
+#ifndef __STRICT_ANSI__
 char *	_EXFUN(_dtoa_r,(struct _reent *, double, int, int, int *, int*, char**));
 #ifndef __CYGWIN__
 _PTR	_EXFUN_NOTHROW(_malloc_r,(struct _reent *, size_t));
@@ -214,6 +221,7 @@
 int	_EXFUN(_system_r,(struct _reent *, const char *));
 
 _VOID	_EXFUN(__eprintf,(const char *, const char *, unsigned int, const char *));
+#endif /* ! __STRICT_ANSI__ */
 
 /* On platforms where long double equals double.  */
 #ifdef _LDBL_EQ_DBL
diff -Naur newlib-1.20.0.orig/newlib/libc/include/string.h newlib-1.20.0/newlib/libc/include/string.h
--- newlib-1.20.0.orig/newlib/libc/include/string.h	2011-06-10 20:30:38.000000000 +0200
+++ newlib-1.20.0/newlib/libc/include/string.h	2011-12-20 18:04:03.936129371 +0100
@@ -50,18 +50,11 @@
 #ifndef __STRICT_ANSI__
 char 	*_EXFUN(strtok_r,(char *, const char *, char **));
 
-int	 _EXFUN(bcmp,(const void *, const void *, size_t));
-void	 _EXFUN(bcopy,(const void *, void *, size_t));
-void	 _EXFUN(bzero,(void *, size_t));
-int	 _EXFUN(ffs,(int));
-char 	*_EXFUN(index,(const char *, int));
 _PTR	 _EXFUN(memccpy,(_PTR, const _PTR, int, size_t));
 _PTR	 _EXFUN(mempcpy,(_PTR, const _PTR, size_t));
 _PTR	 _EXFUN(memmem, (const _PTR, size_t, const _PTR, size_t));
-char 	*_EXFUN(rindex,(const char *, int));
 char 	*_EXFUN(stpcpy,(char *, const char *));
 char 	*_EXFUN(stpncpy,(char *, const char *, size_t));
-int	 _EXFUN(strcasecmp,(const char *, const char *));
 char	*_EXFUN(strcasestr,(const char *, const char *));
 char 	*_EXFUN(strchrnul,(const char *, int));
 char 	*_EXFUN(strdup,(const char *));
@@ -84,14 +77,11 @@
 #endif
 size_t	 _EXFUN(strlcat,(char *, const char *, size_t));
 size_t	 _EXFUN(strlcpy,(char *, const char *, size_t));
-int	 _EXFUN(strncasecmp,(const char *, const char *, size_t));
 size_t	 _EXFUN(strnlen,(const char *, size_t));
 char 	*_EXFUN(strsep,(char **, const char *));
 char	*_EXFUN(strlwr,(char *));
 char	*_EXFUN(strupr,(char *));
-#ifndef DEFS_H	/* Kludge to work around problem compiling in gdb */
-char  *_EXFUN(strsignal, (int __signo));
-#endif
+char	*_EXFUN(strsignal, (int __signo));
 #ifdef __CYGWIN__
 int     _EXFUN(strtosigno, (const char *__name));
 #endif
@@ -113,20 +103,6 @@
 			 (char *) memcpy (__out, __in, __len-1);}))
 #endif /* _GNU_SOURCE && __GNUC__ */
 
-/* These function names are used on Windows and perhaps other systems.  */
-#ifndef strcmpi
-#define strcmpi strcasecmp
-#endif
-#ifndef stricmp
-#define stricmp strcasecmp
-#endif
-#ifndef strncmpi
-#define strncmpi strncasecmp
-#endif
-#ifndef strnicmp
-#define strnicmp strncasecmp
-#endif
-
 #endif /* ! __STRICT_ANSI__ */
 
 #include <sys/string.h>
diff -Naur newlib-1.20.0.orig/newlib/libc/include/sys/_default_fcntl.h newlib-1.20.0/newlib/libc/include/sys/_default_fcntl.h
--- newlib-1.20.0.orig/newlib/libc/include/sys/_default_fcntl.h	2010-01-14 19:49:13.000000000 +0100
+++ newlib-1.20.0/newlib/libc/include/sys/_default_fcntl.h	2011-12-20 18:04:03.937129387 +0100
@@ -51,8 +51,6 @@
 #define O_BINARY	_FBINARY
 #define O_TEXT		_FTEXT
 #define O_NOINHERIT	_FNOINHERIT
-/* O_CLOEXEC is the Linux equivalent to O_NOINHERIT */
-#define O_CLOEXEC	_FNOINHERIT
 
 /* The windows header files define versions with a leading underscore.  */
 #define _O_RDONLY	O_RDONLY
@@ -124,9 +122,6 @@
 #define	F_CNVT 		12	/* Convert a fhandle to an open fd */
 #define	F_RSETLKW 	13	/* Set or Clear remote record-lock(Blocking) */
 #endif	/* !_POSIX_SOURCE */
-#ifdef __CYGWIN__
-#define	F_DUPFD_CLOEXEC	14	/* As F_DUPFD, but set close-on-exec flag */
-#endif
 
 /* fcntl(2) flags (l_type field of flock structure) */
 #define	F_RDLCK		1	/* read lock */
diff -Naur newlib-1.20.0.orig/newlib/libc/include/sys/resource.h newlib-1.20.0/newlib/libc/include/sys/resource.h
--- newlib-1.20.0.orig/newlib/libc/include/sys/resource.h	2000-02-17 20:39:46.000000000 +0100
+++ newlib-1.20.0/newlib/libc/include/sys/resource.h	2011-12-20 18:04:03.940129433 +0100
@@ -6,10 +6,22 @@
 #define	RUSAGE_SELF	0		/* calling process */
 #define	RUSAGE_CHILDREN	-1		/* terminated child processes */
 
+#ifdef __cplusplus
+extern "C" {
+#endif
+
 struct rusage {
   	struct timeval ru_utime;	/* user time used */
 	struct timeval ru_stime;	/* system time used */
 };
 
+#if defined(__rtems__)
+int _EXFUN(getrusage,(int who, struct rusage *usage));
+#endif
+
+#ifdef __cplusplus
+}
+#endif
+
 #endif
 
diff -Naur newlib-1.20.0.orig/newlib/libc/include/sys/time.h newlib-1.20.0/newlib/libc/include/sys/time.h
--- newlib-1.20.0.orig/newlib/libc/include/sys/time.h	2009-10-09 20:43:12.000000000 +0200
+++ newlib-1.20.0/newlib/libc/include/sys/time.h	2011-12-20 18:04:03.940129433 +0100
@@ -78,6 +78,11 @@
 int _EXFUN(setitimer, (int __which, const struct itimerval *__value,
 					struct itimerval *__ovalue));
 
+#if defined(__rtems__)
+/* BSD function used by RTEMS code */
+int _EXFUN(adjtime,(const struct timeval *, struct timeval *));
+#endif
+
 #ifdef __cplusplus
 }
 #endif
diff -Naur newlib-1.20.0.orig/newlib/libc/machine/arm/arm_asm.h newlib-1.20.0/newlib/libc/machine/arm/arm_asm.h
--- newlib-1.20.0.orig/newlib/libc/machine/arm/arm_asm.h	2011-10-18 13:35:17.000000000 +0200
+++ newlib-1.20.0/newlib/libc/machine/arm/arm_asm.h	2011-12-20 18:04:03.941129448 +0100
@@ -62,22 +62,7 @@
 
 
 /* Now some macros for common instruction sequences.  */
-#ifdef __ASSEMBLER__
-.macro  RETURN     cond=
-#if defined (_ISA_ARM_4T) || defined (_ISA_THUMB_1)
-	bx\cond	lr
-#else
-	mov\cond pc, lr
-#endif
-.endm
-
-.macro optpld	base, offset=#0
-#if defined (_ISA_ARM_7)
-	pld	[\base, \offset]
-#endif
-.endm
 
-#else
 asm(".macro  RETURN	cond=\n\t"
 #if defined (_ISA_ARM_4T) || defined (_ISA_THUMB_1)
     "bx\\cond	lr\n\t"
@@ -93,6 +78,5 @@
 #endif
     ".endm"
     );
-#endif
 
 #endif /* ARM_ASM__H */
diff -Naur newlib-1.20.0.orig/newlib/libc/machine/arm/Makefile.am newlib-1.20.0/newlib/libc/machine/arm/Makefile.am
--- newlib-1.20.0.orig/newlib/libc/machine/arm/Makefile.am	2011-10-18 13:35:17.000000000 +0200
+++ newlib-1.20.0/newlib/libc/machine/arm/Makefile.am	2011-12-20 18:04:03.941129448 +0100
@@ -8,9 +8,7 @@
 
 noinst_LIBRARIES = lib.a
 
-lib_a_SOURCES = setjmp.S access.c strlen.c strcmp.c strcpy.c \
-	        memcpy.S memcpy-stub.c memchr-stub.c memchr.S \
-		strlen.c strlen-armv7.S
+lib_a_SOURCES = setjmp.S access.c strlen.c strcmp.c strcpy.c
 lib_a_CCASFLAGS=$(AM_CCASFLAGS)
 lib_a_CFLAGS = $(AM_CFLAGS)
 
diff -Naur newlib-1.20.0.orig/newlib/libc/machine/arm/strlen.c newlib-1.20.0/newlib/libc/machine/arm/strlen.c
--- newlib-1.20.0.orig/newlib/libc/machine/arm/strlen.c	2011-10-18 13:35:17.000000000 +0200
+++ newlib-1.20.0/newlib/libc/machine/arm/strlen.c	2011-12-20 18:04:03.943129483 +0100
@@ -60,8 +60,6 @@
 }
 #else
 
-#if !(defined(_ISA_ARM_7) || defined(__ARM_ARCH_6T2__))
-
 size_t __attribute__((naked))
 strlen (const char* str)
 {
@@ -180,4 +178,3 @@
        "RETURN");
 }
 #endif
-#endif
diff -Naur newlib-1.20.0.orig/newlib/libc/machine/m68k/memcpy.S newlib-1.20.0/newlib/libc/machine/m68k/memcpy.S
--- newlib-1.20.0.orig/newlib/libc/machine/m68k/memcpy.S	2010-02-08 18:24:22.000000000 +0100
+++ newlib-1.20.0/newlib/libc/machine/m68k/memcpy.S	2011-12-20 18:04:03.943129483 +0100
@@ -15,7 +15,7 @@
 
 #include "m68kasm.h"
 
-#if defined (__mcoldfire__) || defined (__mc68010__) || defined (__mc68020__) || defined (__mc68030__) || defined (__mc68040__) || defined (__mc68060__)
+#if defined (__mcoldfire__) || defined (__mcpu32__) || defined (__mc68010__) || defined (__mc68020__) || defined (__mc68030__) || defined (__mc68040__) || defined (__mc68060__)
 # define MISALIGNED_OK 1
 #else
 # define MISALIGNED_OK 0
diff -Naur newlib-1.20.0.orig/newlib/libc/machine/powerpc/Makefile.am newlib-1.20.0/newlib/libc/machine/powerpc/Makefile.am
--- newlib-1.20.0.orig/newlib/libc/machine/powerpc/Makefile.am	2007-05-24 19:33:35.000000000 +0200
+++ newlib-1.20.0/newlib/libc/machine/powerpc/Makefile.am	2011-12-20 18:04:03.943129483 +0100
@@ -10,7 +10,7 @@
 
 AM_CFLAGS = -I $(srcdir)/../../stdio -I $(srcdir)/../../stdlib
 
-lib_a_SOURCES = setjmp.S times.c
+lib_a_SOURCES = setjmp.S
 lib_a_CCASFLAGS=$(AM_CCASFLAGS)
 lib_a_CFLAGS=$(AM_CFLAGS)
 lib_a_LIBADD = @extra_objs@
diff -Naur newlib-1.20.0.orig/newlib/libc/Makefile.am newlib-1.20.0/newlib/libc/Makefile.am
--- newlib-1.20.0.orig/newlib/libc/Makefile.am	2011-01-05 18:18:16.000000000 +0100
+++ newlib-1.20.0/newlib/libc/Makefile.am	2011-12-20 18:04:03.933129312 +0100
@@ -36,6 +36,8 @@
 
 if HAVE_XDR_DIR
 XDR_SUBDIR = xdr
+rpcincludedir = $(tooldir)
+nobase_rpcinclude_HEADERS = include/rpc/xdr.h include/rpc/types.h
 endif
 
 # The order of SUBDIRS is important for the integrated documentation.
diff -Naur newlib-1.20.0.orig/newlib/libc/misc/__dprintf.c newlib-1.20.0/newlib/libc/misc/__dprintf.c
--- newlib-1.20.0.orig/newlib/libc/misc/__dprintf.c	2008-12-11 18:27:55.000000000 +0100
+++ newlib-1.20.0/newlib/libc/misc/__dprintf.c	2011-12-20 18:04:03.944129501 +0100
@@ -5,6 +5,7 @@
 */
 
 #include <_ansi.h>
+#include <stdint.h>
 #include "ctype.h"
 #include "reent.h"
 #include "string.h"
@@ -131,7 +132,7 @@
 	      write_string (unctrl (c));
 	      break;
 	    case 'p' :
-	      l = (_POINTER_INT) va_arg (args, char *);
+	      l = (intptr_t) va_arg (args, char *);
 	      print_number (16, 1, l);
 	      break;
 	    case 'd' :
